=begin
#ocrapi

#The powerful Optical Character Recognition (OCR) APIs let you convert scanned images of pages into recognized text.

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'date'

module CloudmersiveOcrApiClient
  # Definition of a column within a table for OCR data extraction from images
  class FormTableColumnDefinition
    # The identifier of the field; use this to identify which field is being referenced
    attr_accessor :column_id

    # Optional - the top anchor of the column heading
    attr_accessor :top_anchor

    # Optional - the matching mode for the anchor.  Possible values are Complete (requires the entire anchor to match) and Partial (allows only part of the anchor to match).  Default is Partial.
    attr_accessor :anchor_mode

    # The data type of the field; possible values are INTEGER (Integer value), STRING (Arbitrary string value, spaces are permitted), DATE (Date in a structured format), DECIMAL (Decimal number), ALPHANUMERIC (Continuous alphanumeric string with no spaces), STRINGNOWHITESPACE (A string that contains no whitespace characters), SERIALNUMBER (A serial-number style string that contains letters and numbers, and certain symbols; must contain at least one number), ALPHAONLY (Alphabet characters only, no numbers or symbols or whitespace)
    attr_accessor :data_type

    # Optional - the target number of digits in the field; useful for fixed-length fields
    attr_accessor :minimum_character_count

    # Optional - set to false to block values that contain numeric digits, set to true to allow numeric digits
    attr_accessor :allow_numeric_digits

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'column_id' => :'ColumnID',
        :'top_anchor' => :'TopAnchor',
        :'anchor_mode' => :'AnchorMode',
        :'data_type' => :'DataType',
        :'minimum_character_count' => :'MinimumCharacterCount',
        :'allow_numeric_digits' => :'AllowNumericDigits'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'column_id' => :'String',
        :'top_anchor' => :'String',
        :'anchor_mode' => :'String',
        :'data_type' => :'String',
        :'minimum_character_count' => :'Integer',
        :'allow_numeric_digits' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'ColumnID')
        self.column_id = attributes[:'ColumnID']
      end

      if attributes.has_key?(:'TopAnchor')
        self.top_anchor = attributes[:'TopAnchor']
      end

      if attributes.has_key?(:'AnchorMode')
        self.anchor_mode = attributes[:'AnchorMode']
      end

      if attributes.has_key?(:'DataType')
        self.data_type = attributes[:'DataType']
      end

      if attributes.has_key?(:'MinimumCharacterCount')
        self.minimum_character_count = attributes[:'MinimumCharacterCount']
      end

      if attributes.has_key?(:'AllowNumericDigits')
        self.allow_numeric_digits = attributes[:'AllowNumericDigits']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          column_id == o.column_id &&
          top_anchor == o.top_anchor &&
          anchor_mode == o.anchor_mode &&
          data_type == o.data_type &&
          minimum_character_count == o.minimum_character_count &&
          allow_numeric_digits == o.allow_numeric_digits
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [column_id, top_anchor, anchor_mode, data_type, minimum_character_count, allow_numeric_digits].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CloudmersiveOcrApiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
