=begin
#ocrapi

#The powerful Optical Character Recognition (OCR) APIs let you convert scanned images of pages into recognized text.

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'date'

module CloudmersiveOcrApiClient
  # A single word in an OCR document
  class OcrWordElement
    # Text of the word
    attr_accessor :word_text

    # Line number of the word
    attr_accessor :line_number

    # Index of the word in the line
    attr_accessor :word_number

    # X location of the left edge of the word in pixels
    attr_accessor :x_left

    # Y location of the top edge of the word in pixels
    attr_accessor :y_top

    # Width of the word in pixels
    attr_accessor :width

    # Height of the word in pixels
    attr_accessor :height

    # Confidence level of the machine learning result; possible values are 0.0 (lowest accuracy) - 1.0 (highest accuracy)
    attr_accessor :confidence_level

    # Index of the containing block
    attr_accessor :block_number

    # Index of the containing paragraph
    attr_accessor :paragraph_number

    # Index of the containing page
    attr_accessor :page_number

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'word_text' => :'WordText',
        :'line_number' => :'LineNumber',
        :'word_number' => :'WordNumber',
        :'x_left' => :'XLeft',
        :'y_top' => :'YTop',
        :'width' => :'Width',
        :'height' => :'Height',
        :'confidence_level' => :'ConfidenceLevel',
        :'block_number' => :'BlockNumber',
        :'paragraph_number' => :'ParagraphNumber',
        :'page_number' => :'PageNumber'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'word_text' => :'String',
        :'line_number' => :'Integer',
        :'word_number' => :'Integer',
        :'x_left' => :'Integer',
        :'y_top' => :'Integer',
        :'width' => :'Integer',
        :'height' => :'Integer',
        :'confidence_level' => :'Float',
        :'block_number' => :'Integer',
        :'paragraph_number' => :'Integer',
        :'page_number' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'WordText')
        self.word_text = attributes[:'WordText']
      end

      if attributes.has_key?(:'LineNumber')
        self.line_number = attributes[:'LineNumber']
      end

      if attributes.has_key?(:'WordNumber')
        self.word_number = attributes[:'WordNumber']
      end

      if attributes.has_key?(:'XLeft')
        self.x_left = attributes[:'XLeft']
      end

      if attributes.has_key?(:'YTop')
        self.y_top = attributes[:'YTop']
      end

      if attributes.has_key?(:'Width')
        self.width = attributes[:'Width']
      end

      if attributes.has_key?(:'Height')
        self.height = attributes[:'Height']
      end

      if attributes.has_key?(:'ConfidenceLevel')
        self.confidence_level = attributes[:'ConfidenceLevel']
      end

      if attributes.has_key?(:'BlockNumber')
        self.block_number = attributes[:'BlockNumber']
      end

      if attributes.has_key?(:'ParagraphNumber')
        self.paragraph_number = attributes[:'ParagraphNumber']
      end

      if attributes.has_key?(:'PageNumber')
        self.page_number = attributes[:'PageNumber']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          word_text == o.word_text &&
          line_number == o.line_number &&
          word_number == o.word_number &&
          x_left == o.x_left &&
          y_top == o.y_top &&
          width == o.width &&
          height == o.height &&
          confidence_level == o.confidence_level &&
          block_number == o.block_number &&
          paragraph_number == o.paragraph_number &&
          page_number == o.page_number
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [word_text, line_number, word_number, x_left, y_top, width, height, confidence_level, block_number, paragraph_number, page_number].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CloudmersiveOcrApiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
