=begin
#ocrapi

#The powerful Optical Character Recognition (OCR) APIs let you convert scanned images of pages into recognized text.

OpenAPI spec version: v1

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'date'

module CloudmersiveOcrApiClient
  # Result of recognizing a receipt, to extract the key information from the receipt
  class ReceiptRecognitionResult
    # True if the operation was successful, false otherwise
    attr_accessor :successful

    # The date and time printed on the receipt (if included on the receipt)
    attr_accessor :timestamp

    # The name of the business printed on the receipt (if included on the receipt)
    attr_accessor :business_name

    # The website URL of the business printed on the receipt (if included on the receipt)
    attr_accessor :business_website

    # The address of the business printed on the receipt (if included on the receipt)
    attr_accessor :address_string

    # The phone number printed on the receipt (if included on the receipt)
    attr_accessor :phone_number

    # The individual line items comprising the order; does not include total (see ReceiptTotal)
    attr_accessor :receipt_items

    # Optional; if available, the monetary value of the receipt subtotal - typically not including specialized line items such as Tax. If this value is not available, it will be 0.
    attr_accessor :receipt_sub_total

    # The total monetary value of the receipt (if included on the receipt)
    attr_accessor :receipt_total

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'successful' => :'Successful',
        :'timestamp' => :'Timestamp',
        :'business_name' => :'BusinessName',
        :'business_website' => :'BusinessWebsite',
        :'address_string' => :'AddressString',
        :'phone_number' => :'PhoneNumber',
        :'receipt_items' => :'ReceiptItems',
        :'receipt_sub_total' => :'ReceiptSubTotal',
        :'receipt_total' => :'ReceiptTotal'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'successful' => :'BOOLEAN',
        :'timestamp' => :'DateTime',
        :'business_name' => :'String',
        :'business_website' => :'String',
        :'address_string' => :'String',
        :'phone_number' => :'String',
        :'receipt_items' => :'Array<ReceiptLineItem>',
        :'receipt_sub_total' => :'Float',
        :'receipt_total' => :'Float'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'Successful')
        self.successful = attributes[:'Successful']
      end

      if attributes.has_key?(:'Timestamp')
        self.timestamp = attributes[:'Timestamp']
      end

      if attributes.has_key?(:'BusinessName')
        self.business_name = attributes[:'BusinessName']
      end

      if attributes.has_key?(:'BusinessWebsite')
        self.business_website = attributes[:'BusinessWebsite']
      end

      if attributes.has_key?(:'AddressString')
        self.address_string = attributes[:'AddressString']
      end

      if attributes.has_key?(:'PhoneNumber')
        self.phone_number = attributes[:'PhoneNumber']
      end

      if attributes.has_key?(:'ReceiptItems')
        if (value = attributes[:'ReceiptItems']).is_a?(Array)
          self.receipt_items = value
        end
      end

      if attributes.has_key?(:'ReceiptSubTotal')
        self.receipt_sub_total = attributes[:'ReceiptSubTotal']
      end

      if attributes.has_key?(:'ReceiptTotal')
        self.receipt_total = attributes[:'ReceiptTotal']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          successful == o.successful &&
          timestamp == o.timestamp &&
          business_name == o.business_name &&
          business_website == o.business_website &&
          address_string == o.address_string &&
          phone_number == o.phone_number &&
          receipt_items == o.receipt_items &&
          receipt_sub_total == o.receipt_sub_total &&
          receipt_total == o.receipt_total
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [successful, timestamp, business_name, business_website, address_string, phone_number, receipt_items, receipt_sub_total, receipt_total].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = CloudmersiveOcrApiClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
